Attribute VB_Name = "modFileDialog"
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Public Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Public Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long

Public Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Public Type BrowseInfo
  hwndOwner As Long
  pIDLRoot As Long
  pszDisplayName As Long
  lpszTitle As Long
  ulFlags As Long
  lpfnCallback As Long
  lParam As Long
  iImage As Long
End Type

Public Const OFN_ALLOWMULTISELECT = &H200      'See Help Note for LFN Behavior
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000            'Windows 95 Only
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000          'Windows 95 Only
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000 'Windows 95 Only
Public Const OFN_NOLONGNAMES = &H40000         'Not Referenced in Help!
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10

Public Const BIF_RETURNONLYFSDIRS = 1
Public Const MAX_PATH = 260

Public Function fBrowseForFolder(hwndOwner As Long, sPrompt As String) As String
  Dim iNull As Integer
  Dim lpIDList As Long
  Dim lResult As Long
  Dim sPath As String
  Dim udtBI As BrowseInfo
  With udtBI
    .hwndOwner = hwndOwner
    .lpszTitle = lstrcat(sPrompt, "")
    .ulFlags = BIF_RETURNONLYFSDIRS
  End With
  lpIDList = SHBrowseForFolder(udtBI)
  If lpIDList Then
    sPath = String$(MAX_PATH, 0)
    lResult = SHGetPathFromIDList(lpIDList, sPath)
    Call CoTaskMemFree(lpIDList)
    iNull = InStr(sPath, vbNullChar)
    If iNull Then
      sPath = Left$(sPath, iNull - 1)
    End If
  End If
  BrowseForFolder = sPath
End Function

Public Function fDialogOpen(oForm As Form, ByVal ftitle As String, fpfad As String, ByVal ffile As String, ByVal ffilter As String, ByVal fext As String) As String
  fDialogOpen = fDialogOpenSave(oForm, ftitle, fpfad, ffile, ffilter, fext, 0)
End Function

Public Function fDialogSave(oForm As Form, ByVal ftitle As String, fpfad As String, ByVal ffile As String, ByVal ffilter As String, ByVal fext As String) As String
  fDialogSave = fDialogOpenSave(oForm, ftitle, fpfad, ffile, ffilter, fext, 1)
End Function

Private Function fDialogOpenSave(oForm As Form, ByVal ftitle As String, fpfad As String, ByVal ffile As String, ByVal ffilter As String, ByVal fext As String, SaveFile As Integer) As String
  Dim O As OPENFILENAME
  Dim wSize As Long, Memhandle As Long

  szFile$ = ffile$ + String$(128 - Len(ffile$), 0)
  szFilter$ = ffilter$ + "||"
  Do While InStr(szFilter$, "|")
    szFilter$ = Left$(szFilter$, InStr(szFilter$, "|") - 1) + Chr$(0) + Mid$(szFilter$, InStr(szFilter$, "|") + 1)
  Loop

  O.lStructSize = Len(O)
  O.hwndOwner = oForm.hwnd
  O.nFilterIndex = 1
  O.nMaxFile = Len(szFile$)

  Select Case SaveFile
    Case 0: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
    Case 1: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT
    Case 2: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
  End Select

  O.lpstrFile = szFile$
  O.lpstrFilter = szFilter$
  O.lpstrTitle = ftitle$
  O.lpstrDefExt = fext$
  O.lpstrInitialDir = fpfad$

  If SaveFile = 0 Then result = GetOpenFileName(O) Else result = GetSaveFileName(O)
  File$ = Left$(O.lpstrFile, InStr(O.lpstrFile, Chr$(0)) - 1)
  If result = 0 Then fDialogOpenSave = "": Exit Function
  fpfad$ = Left$(File$, O.nFileOffset)
  fDialogOpenSave = Right$(File$, Len(File$) - O.nFileOffset)
End Function

